module resultados

! objetivo: escrever resultados e apresentar grficos

use calculos

implicit none

contains

!-----------------------------------------------------------------------------------------------------------

  subroutine mostra_resultados

    call escreve_tabs_1_2
    call escreve_tab_3
    call escreve_tab_4
    call escreve_ordens_h
    call escreve_ordens_i
    call escreve_ordens_bi
    call escreve_ordens_c
    call escreve_ordens_mer
    call escreve_incertezas
    call grafico_ordens
    call grafico_incertezas

  end subroutine mostra_resultados

!------------------------------------------------------------------------------------------------------------
  
  subroutine escreve_tabs_1_2
  
   !escrita dos dados das Tabelas 1 e 2 do arquivo txt de saida
          
    character(22), dimension(nm) :: pU_h1_c, pU_MER_c, pU_c1_c, pU_i1_c, pU_bi1_c, &
                                    psi_v_c, psi_inter_c, psi_c_c, psi_i1_c, psi_bi1_c                 
    
    pU_h1_c = ' '; pU_MER_c = ' '; pU_c1_c = ' '; pU_i1_c = ' '; 
    pU_bi1_c = ' '; psi_v_c = ' '; psi_inter_c = ' '; psi_c_c = ' '; 
    psi_i1_c = ' '; psi_bi1_c = ' ';
    
    write(out,1) 
    1 format(2/, 3x,'h', 15x,'pU*(Th)', 15x,'pU*(Tm1)', 14x,'pU*(Tc)',  & 
                 15x,'pU*(Ti_pU*)',13x,'pU*(Tbi_pU*)')  
    
    do i = 1, nm 
       if ( pU_h1(i) /= great ) write(pU_h1_c(i),'(1pe22.9)') pU_h1(i)
       if ( pU_MER(i) /= great )  write(pU_MER_c(i),'(1pe22.9)') pU_MER(i)
       if ( pU_c1(i) /= great )  write(pU_c1_c(i),'(1pe22.9)') pU_c1(i)
       if ( pU_i1(i)  /= great )  write(pU_i1_c(i) ,'(1pe22.9)') pU_i1(i) 
       if ( pU_bi1(i)  /= great )  write(pU_bi1_c(i) ,'(1pe22.9)') pU_bi1(i)   
       write(out,2) h(i), pU_h1_c(i), pU_MER_c(i), pU_c1_c(i),pU_i1_c(i), pU_bi1_c(i)
    end do   
    
    2 format(1pe12.4, 6(a22))   

       write(out,6) 
       6 format(2/, 3x,'h', 15x,'psi(Th)', 15x,'psi(Tm1)', 14x,'psi(Tc)',  & 
                 15x,'psi(Ti_pU) ',11x,'psi(Tbi_pU)')
    
  do i = 1, nm 
       if ( psi_v(i) /= great ) write(psi_v_c(i),'(1pe22.9)') psi_v(i)
       if ( psi_inter(i) /= great )  write(psi_inter_c(i),'(1pe22.9)') psi_inter(i)
       if ( psi_c(i) /= great )  write(psi_c_c(i),'(1pe22.9)') psi_c(i)
       if ( psi_i1(i)  /= great )  write(psi_i1_c(i) ,'(1pe22.9)') psi_i1(i) 
       if ( psi_bi1(i)  /= great )  write(psi_bi1_c(i) ,'(1pe22.9)') psi_bi1(i)  
       write(out,2) h(i), psi_v_c(i), psi_inter_c(i), psi_c_c(i),psi_i1_c(i), psi_bi1_c(i)
    end do 
  
  end subroutine escreve_tabs_1_2

!-----------------------------------------------------------------------------------------------------------
  
  subroutine escreve_tab_3
  
   !escrita dos dados da Tabela 3 do arquivo txt de saida

    write(out,1) 
    1 format(2/, 3x,'h', 17x,'Th', 44x,'Tm1', 43x,'Tc')

    write(out,2) h(1), Th(1)
    write(out,3) h(2), Th(2), T_MER(2)
    2 format(1pe12.3, 1pe46.31)
    3 format(1pe12.3,2(1pe46.31))
    4 format(1pe12.3,3(1pe46.31))
    
    if ( nm >= 3 ) then
       do i = 3, nm
          if( T_c(i)/=great ) then 
             write(out,4) h(i), Th(i),T_MER(i), T_c(i)
          else
             write(out,4) h(i), Th(i),T_MER(i)
          end if   
       end do   
    end if
  
  end subroutine escreve_tab_3

!-----------------------------------------------------------------------------------------------------------

  subroutine escreve_tab_4
  
    !escrita dos dados da Tabela 4 do arquivo txt de saida
        
    character(22), dimension(nm) :: U_GCI_c, U_mc_c, U_Ri_mpsi_MER_c, U_c_c               
    
    U_GCI_c = ' '; U_mc_c = ' '; U_Ri_mpsi_MER_c = ' '; U_c_c = ' '; 
    
    write(out,1) 
    1 format(2/, 3x,'h', 11x,'UGCI(Th) ', 12x,'Umc(Th)', 16x,'Um(Tm1)', 15x,'Uc(Tc) ')   
    
    do i = 1, nm 
       if ( U_GCI(i) /= great ) write(U_GCI_c(i),'(1pe15.6)') U_GCI(i)
       if ( U_mc(i) /= great )  write(U_mc_c(i),'(1pe15.6)') U_mc(i)
       if ( U_Ri_mpsi_MER(i) /= great )  write(U_Ri_mpsi_MER_c(i),'(1pe15.6)') U_Ri_mpsi_MER(i)
       if ( U_c(i)  /= great )  write(U_c_c(i) ,'(1pe15.6)') U_c(i)   
       write(out,2) h(i), U_GCI_c(i), U_mc_c(i), U_Ri_mpsi_MER_c(i), U_c_c(i)
    end do   
    
    2 format(1pe12.4, 12(a22))    
    
  end subroutine escreve_tab_4


!-----------------------------------------------------------------------------------------------------------

  subroutine escreve_ordens_h
  
    !escrita de ordem da soluo numrica sem extrapolao

    open(out2,file='p0.dat')
    
    2 format(1pe12.4,1pe22.14,22x,1pe22.14)
    
    write(out2,7)
    
    7 format ('#', t4,'log(h)', t27,'p0' )
    
    do i = 1, nm
       write(out2,8) qlog10(h(i)), pL
    end do
    
    8 format(2(1pe12.4))
    
    close(out2)

   open(out2,file='pU_h.dat')
   
    write(out2,6)
    
    6 format ('#', t4,'log(h)', t27,'pU_h' )
    
    if ( nm >= 3 ) then
       do i = 3, nm
          if ( pU_h1(i) < limite ) then
             write(out2,2) qlog10(h(i)), pU_h1(i)
          else
             write(out2,8)
          end if
       end do
    end if
    
    close(out2)

  end subroutine escreve_ordens_h

!-----------------------------------------------------------------------------------------------------------

  subroutine escreve_ordens_i
  
    !escrita de ordem para a soluo extrapolada
    
    2 format(1pe12.4,1pe22.14,22x,1pe22.14)
    
    open(out2,file='p1.dat')
    
    write(out2,7)
    
    7 format ('#', t4,'log(h)', t27,'p1' )
    
    do i = 1, nm
       write(out2,8) qlog10(h(i)), pV(2)
    end do
    
    8 format(2(1pe12.4))
    
    close(out2)

    open(out2,file='pU_i.dat')
    
    write(out2,9)
    
    9 format ('#', t4,'log(h)', t27,'pU_i' )
    
    if ( nm >= 5 ) then
       do i = 5, nm
          if ( pU_i1(i) < limite ) then
             write(out2,2) qlog10(h(i)), pU_i1(i)
          else
             write(out2,2)
          end if
       end do
    end if
    
    close(out2)

  end subroutine escreve_ordens_i

!-----------------------------------------------------------------------------------------------------------

  subroutine escreve_ordens_bi
  
    !escrita de ordem para a soluo biextrapolada

    2 format(1pe12.4,1pe22.14,22x,1pe22.14)
   
    open(out2,file='p2.dat')
    
    write(out2,7)
    
    7 format ('#', t4,'log(h)', t27,'p2' )
    
    do i = 1, nm
       write(out2,8) qlog10(h(i)), pV(3)
    end do
    
    8 format(2(1pe12.4))
    
    close(out2)

    open(out2,file='pU_bi.dat')
    
    write(out2,9)
    9 format ('#', t4,'log(h)', t27,'pU_bi' )
    
    if ( nm >= 7 ) then
       do i = 7, nm
          if ( pU_bi1(i) < limite ) then
             write(out2,2) qlog10(h(i)), pU_bi1(i)
          else
             write(out2,2)
          end if
       end do
    end if
    
    close(out2)

  end subroutine escreve_ordens_bi

!-----------------------------------------------------------------------------------------------------------

  subroutine escreve_ordens_c
  
    !escrita de ordem aparente para a soluo convergente
    
    2 format(1pe12.4,1pe22.14,22x,1pe22.14)
    
    open(out2,file='pU_c.dat')
    
    write(out2,6)
    
    6 format ('#', t4,'log(h)', t27,'pU_c' )
    
    if ( nm >= 5 ) then
       do i = 5, nm
          if ( pU_c1(i) < limite ) then
             write(out2,2) qlog10(h(i)), pU_c1(i)
          else
             write(out2,2)
          end if
       end do
    end if
    
    close(out2)

  end subroutine escreve_ordens_c


!----------------------------------------------------------------------------------------------------------

  subroutine escreve_ordens_mer
  
    ! escrita de ordem aparente para a soluo com MER
    
   2 format(1pe12.4,1pe22.14,22x,1pe22.14)
   
   open(out2,file='pU_mer.dat')
   
    write(out2,6)
    
    6 format ('#', t4,'log(h)', t27,'pU*(Tm1)' )
    
    if ( nm >= 3 ) then
       do i = 3, nm
          if ( pU_MER(i) < limite ) then
             write(out2,2) qlog10(h(i)), pU_MER(i)
          else
             write(out2,2)
          end if
       end do
    end if
    
    close(out2)

  end subroutine escreve_ordens_mer


!-----------------------------------------------------------------------------------------------------------

  subroutine escreve_incertezas
  
    ! escrita de incertezas
    
    2 format(1pe12.4,1pe22.14)
       
    open(out2,file='U_12.dat')
    
    write(out2,3)
    
    3 format ('#', t3,'log(h)', t15,'log|UGCI(Th)|' )
    
    do i = 2, nm
       if ( U_GCI(i) /= great ) then
           write(out2,2) qlog10(h(i)), qlog10(qabs(U_GCI(i)))
       else
           write(out2,2)
       end if
    end do
    
    close(out2)
    
    open(out2,file='U_13.dat')
    
    write(out2,4)
    
    4 format ('#', t3,'log(h)', t15, 'log|Umc(Th)|' )
    
    do i = 2, nm
       if ( U_mc(i) /= great ) then
           write(out2,2) qlog10(h(i)), qlog10(qabs(U_mc(i)))
       else
           write(out2,2)
       end if
    end do
    
    close(out2)
    
   open(out2,file='U_14.dat')
   
    write(out2,5)
    
    5 format ('#', t3,'log(h)', t15,' log|Uc(Tc)|')
    
    do i = 2, nm
       if ( U_c(i)  /= great ) then
           write(out2,2) qlog10(h(i)), qlog10(qabs(U_c(i)))
       else
           write(out2,2)
       end if
    end do
    
    close(out2)
    
    open(out2,file='U_15.dat')
    
    write(out2,6)
    
    6 format ('#', t3,'log(h)', t15,' log|Um(Tm1)|')
    
    do i = 2, nm
       if ( U_Ri_mpsi_MER(i) /= great  ) then
           write(out2,2) qlog10(h(i)), qlog10(qabs(U_Ri_mpsi_MER(i)))
       else
           write(out2,2)
       end if
    end do
    
    close(out2)

 end subroutine escreve_incertezas

!-----------------------------------------------------------------------------------------------------------


  subroutine grafico_ordens

       ! grfico de ordens

       open(out2,file='Richardson_4p0_pU.gnu')

       do k = 1, 15
          read(out2,*)
       end do

        1 format("set title '", a, /, "replot")
       
       write(out2,1) trim(adjustl(head))

       close(out2)

       dos = system('wgnuplot Richardson_4p0_pU.gnu')

  end subroutine grafico_ordens


!-----------------------------------------------------------------------------------------------------------

  subroutine grafico_incertezas

       ! grfico de incertezas

       open(out2,file='Richardson_4p0_U.gnu')

       do k = 1, 10
          read(out2,*)
       end do

       write(out2,1) trim(adjustl(head))

       close(out2)

       dos = system('wgnuplot Richardson_4p0_U.gnu')
       
       1 format("set title '", a, /, "replot")

  end subroutine grafico_incertezas

!----------------------------------------------------------------------------------------------------------

end module resultados
